Subject: linux-next: manual merge of the fs-next tree with the mm-unstable tree

From: Mark Brown <[email-masked]>
Date: Mon, 25 May 2026 14:55:53 +0100

Hi all,

Today's linux-next merge of the fs-next tree got a conflict in:

  fs/btrfs/defrag.c

between commit:

  5573c81882722 ("fs/btrfs: remove a comment referring to READ_ONLY_THP_FOR_FS")

from the mm-unstable tree and commit:

  871bf8cef0139 ("btrfs: move large data folios out of experimental features")

from the fs-next tree.

I fixed it up (see below) and can carry the fix as necessary. This
is now fixed as far as linux-next is concerned, but any non trivial
conflicts should be mentioned to your upstream maintainer when your tree
is submitted for merging.  You may also want to consider cooperating
with the maintainer of the conflicting tree to minimise any particularly
complex conflicts.

diff --combined fs/btrfs/defrag.c
index a8d49d9ca981c,f0c6758b7055d..0000000000000
--- a/fs/btrfs/defrag.c
+++ b/fs/btrfs/defrag.c
@@@ -859,20 -859,6 +859,6 @@@ again
  	if (IS_ERR(folio))
  		return folio;
  
- 	/*
- 	 * The IO for such large folios is not fully tested, thus return
- 	 * an error to reject such folios unless it's an experimental build.
- 	 *
- 	 * Filesystem transparent huge pages are typically only used for
- 	 * executables that explicitly enable them, so this isn't very
- 	 * restrictive.
- 	 */
- 	if (!IS_ENABLED(CONFIG_BTRFS_EXPERIMENTAL) && folio_test_large(folio)) {
- 		folio_unlock(folio);
- 		folio_put(folio);
- 		return ERR_PTR(-ETXTBSY);
- 	}
- 
  	ret = set_folio_extent_mapped(folio);
  	if (ret < 0) {
  		folio_unlock(folio);
@@@ -1176,7 -1162,6 +1162,6 @@@ static int defrag_one_locked_target(str
  		if (start >= folio_next_pos(folio) ||
  		    start + len <= folio_pos(folio))
  			continue;
- 		btrfs_folio_clamp_clear_checked(fs_info, folio, start, len);
  		btrfs_folio_clamp_set_dirty(fs_info, folio, start, len);
  	}
  	btrfs_delalloc_release_extents(inode, len);